/* Types.pmod
 *
 * Typobjekten kan bara konvertera sig sjlva till och frn
 * protokoll A och till och frn ett format som kan sparas i databasen.
 *
 * Metoder:
 *
 * init_db(mixed)
 * init_protA(array(object(Token)))
 * int size_protA()
 *
 * mixed query_db()
 * string query_protA()
 */

#include "Types.h"

#define WERROR werror

#if 0
class Field
{
  string type;
  string name;
  array attributes; /* Fr bitstrngar */
  void create(string t, string n, array(string)|void a)
  {
    type = t;
    name = n;
    attributes = a;
  }
}
#endif

class Generic
{
  constant fields = ({ });
  
  array(array) query_fields()
    {
      return fields;
      // return _Types.query_fields(object_program(this_object()));
    }

  object init_protA(array tokens, array|void wanted)
    {
      int index=0;
      array fields = wanted || query_fields();
      foreach(fields, object f)
	{
	  if (index > sizeof(tokens))
	    return 0;
	  object t = tokens[index];
	  WERROR(sprintf("init_protA: token = < %s, %O >\n"
			 "            field = < %s, %s >.\n",
			 t->token, t->value, TYPE(f), NAME(f)));
	  switch(TYPE(f))
	    {
	    case "int":
	      if (t->token != "int")
		return 0;
	      this_object()[NAME(f)] = (int) t->value;
	      index++;
	      break;
	    case "string":
	      if (t->token != "string")
		return 0;
	      this_object()[NAME(f)] = t->value;
	      index++;
	      break;
	    case "bitstring":
	      { /* Den minst signifikanta bitten frst. */
		if ( (t->token != "int")
		     || sizeof(replace(t->value,
				       ({ "0", "1" }), ({ "", "" }))))
		  return 0;

		int res = 0;
		int mask = 1;
		// if (strlen(t->value) > BITSTRING_LEN(f))
		//   return 0;
		foreach(values(t->value), int digit)
		  {
		    if (digit == '1')
		      res |= mask;
		    mask *= 2;
		  }
		this_object()[NAME(f)] = res;
		index++;
		break;
	      }
	    case "time":
	      {
		if (sizeof(tokens) < (index + 9))
		  return 0;
		array a = protocol_A.parse_time(tokens[index..index+8]);
		if (!a)
		  return 0;
		this_object()[NAME(f)] = a[1];
		index += 9;
	      }
	    case "array":
	      {
		if (t->token != "int")
		  return 0;
		int size = (int) t->value;
		index++;
		if (index >= sizeof(tokens))
		  return 0;
		t = tokens[index];
		if (t->token != "array")
		  return 0;
		array a = t->value;
		index++;

		/* Avkoda arrayen */
		array res = allocate(size);
		if (ARRAY_TYPE(f) == "int")
		  {
		    if (sizeof(a) != size)
		      return 0;
		    for(int i = 0; i<size; i++)
		      {
			if (a[i]->token != "int")
			  return 0;
			res[i] = (int) a[i]->value;
		      }
		  } else {
		    int j = 0; /* Avkodade tokens */
		    for(int i = 0; i<size; i++)
		      {
			if (j >= sizeof(a))
			  return 0;
			object o = ARRAY_TYPE(f)();
			int len = o->size_protA(a[j]);
			if (!len || (sizeof(a) < (j + len)))
			  return 0;
			o = o->init_protA(a[j..j + len - 1]);
			if (!o)
			  return 0;
			res[i] = o;
			j += len;
		      }
		  }
		this_object()[NAME(f)] = res;
		break;
	      }
	    default:
	      object v = _Types.query_program(TYPE(f))();
	      int len = v->size_protA();
	      v = v->init_protA(tokens[index..index + len -1]);
	      if (!v)
		return 0;
	      this_object()[NAME(f)] = v;
	      index += len;
	      break;
	    }
	}
      return this_object();
    }

    string query_protA(array|void wanted)
    {
      array fields = wanted||query_fields();

      return Array.map(fields, lambda(object f, object me) {
	switch(TYPE(f))
	  {
	  case "int":
	    return protocol_A.int_to_A(me[NAME(f)]);
	  case "string":
	    return protocol_A.string_to_A(me[NAME(f)]);
	  case "bitstring":
	    return protocol_A.bitstring_to_A(me[NAME(f)],
					     BITSTRING_LEN(f));
	  case "time":
	    return protocol_A.time_to_A(me[NAME(f)]);
	  case "array":
	    {
	      int size = sizeof(me[NAME(f)]);
	      if (!size)
		return "0 *";
	      
	      return protocol_A.int_to_A(size)
		+ " { "
                + Array.map(me[NAME(f)], (ARRAY_TYPE(f) == "int"
					  ? protocol_A.int_to_A
					  : "query_protA")) * " "
                + " }";
	    }
	  default:
	    return me[NAME(f)]->query_protA();
	  }
      }, this_object()) * " ";
    }
}

/* Behver man den hr? Det kanske r bttre att anvnda
 * enbart Extended_Conf_Type, och hoppas att klienter klarar
 * verfldiga bittar i bitstrngen. */

constant conf_rd_prot = 1;
constant conf_original = 2;
constant conf_secret = 4;
constant conf_letterbox = 8;
constant conf_allow_anon = 16;
#if 0
constant conf_reserved1 = 32;
constant conf_reserved2 = 64;
constant conf_reserved3 = 128;
#endif

class Conf_Type
{
  inherit Generic;
  constant fields = ({ FIELD3("bitstring", "type", 4) });

  bitstring_t type;
}

class Extended_Conf_Type
{
  inherit Conf_Type;
  constant fields = ({ FIELD3("bitstring", "type", 8) });
}

class Conf_List_Item
{
  inherit Generic;
  constant fields = ({ FIELD("int", "conference"),
		       FIELD("Conf_Type", "conf_type") });

  int conference;
  bitstring_t conf_type;
}

#if 0
class Conf_List
{
  inherit Generic_Array;
  constant item_type = Conf_List_Item;
}
#endif

class Conf_Z_Info
{
  inherit Generic;
  constant fields = ({ FIELD("string", "name"),
		       FIELD3("bitstring", "type", 4),
		       FIELD("int", "conf_no") });

  string name;
  bitstring_t type;
  int conf_no;
}

#if 0
class Conf_Z_Info_List
{
  inherit Generic_Array;
  constant item_type = Conf_Z_Info;
}
#endif

class Conference
{
  inherit Generic;
  
  constant fields = ({ FIELD("string", "name"),
		       FIELD3("bitstring", "type", 4),
		       FIELD("time", "creation_time"),
		       FIELD("time", "last_written"),
		       FIELD("int", "creator"),
		       FIELD("int", "presentation"),
		       FIELD("int", "supervisor"),
		       FIELD("int", "permitted_submitters"),
		       FIELD("int", "super_conf"),
		       FIELD("int", "msg_of_day"),
		       FIELD("int", "nice"),
		       FIELD("int", "no_of_members"),
		       FIELD("int", "first_local_no"),
		       FIELD("int", "no_of_texts") });
  
  string name;
  bitstring_t type;
  time_t creation_time;
  time_t last_written;
  int creator;
  int presentation;
  int supervisor;
  int permitted_submitters;
  int super_conf;
  int msg_of_day;
  int nice;
  int no_of_members;
  int first_local_no;
  int no_of_texts;
}

class UConference
{
  inherit Generic;
  constant fields = ({ FIELD("string", "name"),
		       FIELD3("bitstring", "type", 8),		       
		       FIELD("int", "highest_local_no"),
		       FIELD("int", "nice") });
  
  string name;
  bitstring_t type;
  int highest_local_no;
  int nice;
}

class Info
{
  inherit Generic;
  constant fields = ({ FIELD("int", "version"),
		       FIELD("int", "conf_pres_conf"),
		       FIELD("int", "pers_pres_conf"),
		       FIELD("int", "motd_conf"),
		       FIELD("int", "conf_news_conf"),
		       FIELD("int", "motd_of_lyskom") });
  
  int version;
  int conf_pres_conf;
  int pers_pres_conf;
  int motd_conf;
  int conf_news_conf;
  int motd_of_lyskom;
}

class Mark
{
  inherit Generic;
  constant fields = ({ FIELD("int", "text_no"),
		       FIELD("int", "type") });

  int text_no;
  int type;
}

class Mark_List
{
  inherit Generic;
  constant fields = ({ FIELD3("array", "contents", Mark) });

  array(object) contents = ({ });
}

class Membership
{
  inherit Generic;

  constant fields = ({ FIELD("time", "last_time_read"),
		       FIELD("int", "conference"),
		       FIELD("int", "priority"),
		       FIELD("int", "last_text_read"),
		       FIELD3("array", "read_texts", "int") });

  time_t last_time_read;
  int conference;
  int priority;
  int last_text_read;
  array(int) read_texts;
}

#if 0
class Membership_List
{
  inherit Generic_Array;
  constant item_type = "Membership";
}
#endif

constant misc_recipient = 0;
constant misc_cc_recipient = 1;
constant misc_comment_to = 2;
constant misc_commented_in = 3;
constant misc_footnote_to = 4;
constant misc_footnoted_in = 5;
constant misc_local_no = 6;
constant misc_received_at = 7;
constant misc_sender = 8;
constant misc_sent_at = 9;
constant misc_bcc_recipient = 10;

class Misc_Info
{
  int type;
  int value;
  
  object init_protA(array(object) a)
  {
    if (a[0]->token != "int")
      return 0;
    type = (int) a[0]->value;
    if ((type == misc_received_at) || (type == misc_sent_at))
      {
	array t = protocol_A.parse_time(a[1..9]);
	if (!t)
	  return 0;
	value = t[0];
      }
    else
      {
	value = (int) a[1]->value;
      }
    return this_object();
    
  }
  
  int size_protA(object t)
  {
    if (!t || (t->token != "int"))
      return 0;
    return ((t->value == "7") || (t->value == "9")) ? 10 : 2;
  }

  string query_protA()
  {
    return protocol_A.int_to_A(type) + " "
      + ( ((type == misc_received_at) || (type == misc_sent_at))
	  ? protocol_A.time_to_A(value)
	  : protocol_A.int_to_A(value) ); 
  }
}

class Misc_Info_List
{
  inherit Generic;
  constant fields = ({ FIELD3("array", "contents", Misc_Info) });
  array(object) contents = ({ });
}

/* Priv_Bits */
constant priv_wheel = 1;
constant prov_admin = 2;
constant priv_statistic = 4;
constant priv_create_pers = 8;
constant priv_create_conf = 0x10;
constant priv_change_name = 0x20;
#if 0
constant priv_flg7 = 0x40;
constant priv_flg8 = 0x80;
constant priv_flg9 = 0x100;
constant priv_flg10 = 0x200;
constant priv_flg11 = 0x400;
constant priv_flg12 = 0x800;
constant priv_flg13 = 0x1000;
constant priv_flg14 = 0x2000;
constant priv_flg15 = 0x4000;
constant priv_flg16 = 0x8000;
#endif

/* Personal_Flags */
constant person_unread_is_secret = 1;
#if 0
constant person_flg2 = 2;
constant person_flg3 = 4;
constant person_flg4 = 8;
constant person_flg5 = 0x10;
constant person_flg6 = 0x20;
constant person_flg7 = 0x40;
constant person_flg8 = 0x80;
#endif

class Person
{
  inherit Generic;
  constant fields = ({ FIELD("string", "username"),
		       FIELD3("bitstring", "privileges", 16),
		       FIELD3("bitstring", "flags", 8),
		       FIELD("time", "last_login"),
		       FIELD("int", "user_area"),
		       FIELD("int", "total_time_present"),
		       FIELD("int", "sessions"),
		       FIELD("int", "created_lines"),
		       FIELD("int", "created_bytes"),
		       FIELD("int", "read_texts"),
		       FIELD("int", "no_of_text_fetches"),
		       FIELD("int", "created_persons"),
		       FIELD("int", "created_confs"),
		       FIELD("int", "first_created_local_no"),
		       FIELD("int", "no_of_created_texts"),
		       FIELD("int", "no_of_marks"),
		       FIELD("int", "no_of_confs") });
  
  string username;
  bitstring_t privileges;
  bitstring_t flags;
  time_t last_login;
  int user_area;
  int total_time_present;
  int sessions;
  int created_lines;
  int created_bytes;
  int read_texts;
  int no_of_text_fetches;
  int created_persons;
  int created_confs;
  int first_created_local_no;
  int no_of_created_texts;
  int no_of_marks;
  int no_of_confs;
}

class Session_Info
{
  inherit Generic;
  constant fields = ({ FIELD("int", "person"),
		       FIELD("int", "working_conference"),
		       FIELD("int", "session"),
		       FIELD("string", "what_am_i_doing"),
		       FIELD("string", "username"),
		       FIELD("int", "idle_time"),
		       FIELD("time", "connection_time") });
  int person;
  int working_conference;
  int session;
  string what_am_i_doing;
  string username;
  int idle_time;
  time_t connection_time;
}

class Session_Info_Ident
{
  inherit Generic;
  constant fields = ({ FIELD("int", "person"),
		       FIELD("int", "working_conference"),
		       FIELD("int", "session"),
		       FIELD("string", "what_am_i_doing"),
		       FIELD("string", "username"),
		       FIELD("string", "hostname"),
		       FIELD("string", "ident_user"),
		       FIELD("int", "idle_time"),
		       FIELD("time", "connection_time") });
  
  int person;
  int working_conference;
  int session;
  string what_am_i_doing;
  string username;
  string hostname;
  string ident_user;
  int idle_time;
  time_t connection_time;
}

constant session_invisible = 1;
constant session_user_active_used = 2;
constant session_user_absent = 4;

class Dynamic_Session_Info
{
  inherit Generic;
  constant fields = ({ FIELD("int", "session"),
		       FIELD("int", "person"),
		       FIELD("int", "working_conference"),
		       FIELD("int", "idle_time"),
		       FIELD3("bitstring", "flags", 8),
		       FIELD("string", "what_am_i_doing") });
  
  int session;
  int person;
  int working_conference;
  int idle_time;
  bitstring_t flags;
  string what_am_i_doing;
}

#if 0
class Dynamic_Session_Info_List
{
  inherit Generic_Array;
  constant item_type = "Dynamic_Session_Info";
}
#endif

class Static_Session_Info
{
  inherit Generic;
  constant fields = ({ FIELD("string", "username"),
		       FIELD("string", "hostname"),
		       FIELD("string", "ident_user"),
		       FIELD("time", "connection_time") });

  string username;
  string hostname;
  string ident_user;
  time_t connection_time;
}

class Text_List
{
  inherit Generic;
  constant fields = ({ FIELD("int", "first_local_no"),
		       FIELD3("array", "texts", "int") });
  
  int first_local_no;
  array(int) texts;
}

class Text_Stat
{
  inherit Generic;
  constant fields = ({ FIELD("time", "creation_time"),
		       FIELD("int", "author"),
		       FIELD("int", "no_of_lines"),
		       FIELD("int", "no_of_chars"),
		       FIELD("int", "no_of_marks"),
		       FIELD3("array", "misc_info", Misc_Info) });
  
  time_t creation_time;
  int author;
  int no_of_lines;
  int no_of_chars;
  int no_of_marks;
  array(object) misc_info;
  // array(object(Aux_Info)) aux_info;   /* Anvnds inte n. */
}

class Version_Info
{
  inherit Generic;
  constant fields = ({ FIELD("int", "protocol_version"),
		       FIELD("string", "server_name"),
		       FIELD("string", "server_version") });

  int protocol_version;
  string server_name;
  string server_version;
}

class Who_Info_Old
{
  inherit Generic;
  constant fields = ({ FIELD("int", "person"),
		       FIELD("string", "what_am_i_doing"),
		       FIELD("int", "working_conference") });
  
  int person;
  string what_am_i_doing;
  int working_conference;
}

#if 0
class Who_Info_Old_List
{
  inherit Generic_Array;
  constant item_type = "Who_Info_Old";
}
#endif

class Who_Info
{
  inherit Generic;
  constant fields = ({ FIELD("int", "person"),
		       FIELD("int", "working_conference"),
		       FIELD("int", "session"),
		       FIELD("string", "what_am_i_doing"),
		       FIELD("string", "username") });
  
  int person;
  int working_conference;
  int session;
  string what_am_i_doing;
  string username;
}

#if 0
class Who_Info_List
{
  inherit Generic_Array;
  constant item_type = "Who_Info";
}
#endif

class Who_Info_Ident
{
  inherit Generic;
  constant fields = ({ FIELD("int", "person"),
		       FIELD("int", "working_conference"),
		       FIELD("int", "session"),
		       FIELD("string", "what_am_i_doing"),
		       FIELD("string", "username"),
		       FIELD("string", "hostname"),
		       FIELD("string", "ident_user") });
  
  int person;
  int working_conference;
  int session;
  string what_am_i_doing;
  string username;
  string hostname;
  string ident_user;
}

#if 0
class Who_Info_Ident_List
{
  inherit Generic_Array;
  constant item_type = "Who_Info_Ident";
}
#endif

void create()
{
  //_Types.register("Time", Time);
  _Types.register("Conf_Type", Conf_Type);
  _Types.register("Extended_Conf_Type", Extended_Conf_Type);
  _Types.register("Conf_List_Item", Conf_List_Item);
  // _Types.register("Conf_List", Conf_List);
  _Types.register("Conf_Z_Info", Conf_Z_Info);
  // _Types.register("Conf_Z_Info_List", Conf_Z_Info_List);
  _Types.register("Conference", Conference);
  _Types.register("UConference", UConference);
  // _Types.register("Session_Flags", Session_Flags);
  _Types.register("Dynamic_Session_Info", Dynamic_Session_Info);
  // _Types.register("Dynamic_Session_Info_List", Dynamic_Session_Info_List);
  _Types.register("Info", Info);
  _Types.register("Mark", Mark);
  _Types.register("Mark_List", Mark_List);
  _Types.register("Membership", Membership);
  // _Types.register("Membership_List", Membership_List);
  _Types.register("Misc_Info", Misc_Info);
  // _Types.register("Misc_Info_List", Misc_Info_List);
  // _Types.register("Priv_Bits", Priv_Bits);
  // _Types.register("Personal_Flags", Personal_Flags);
  _Types.register("Person", Person);
  _Types.register("Session_Info", Session_Info);
  _Types.register("Session_Info_Ident", Session_Info_Ident);
  _Types.register("Static_Session_Info", Static_Session_Info);
  _Types.register("Text_List", Text_List);
  _Types.register("Text_Stat", Text_Stat);
  _Types.register("Version_Info", Version_Info);
  _Types.register("Who_Info_Old", Who_Info_Old);
  // _Types.register("Who_Info_Old_List", Who_Info_Old_List);
  _Types.register("Who_Info", Who_Info);
  // _Types.register("Who_Info_List", Who_Info_List);
  _Types.register("Who_Info_Ident", Who_Info_Ident);
  // _Types.register("Who_Info_Ident_List", Who_Info_Ident_List);
}
