/* lyskomd.pike
 *
 */

#define WERROR werror

object db;  /* Database */
object socket;

object queue;

void create()
{
  queue = Thread.Queue();
  socket = Stdio.Port();
}

void enqueue_request(object r)
{
  WERROR(sprintf("lyskomd.pike: enqueue_request(%O)\n", r));
  queue->write(r);
}

int main(int argc, array(string) argv)
{
  // _verify_internals();
  socket->bind(Config.query_var("portno"), lambda(mixed id) {
    object f = socket->accept();
    if (f)
      Connection(f, this_object());
  });

  for(int i = 0; i<Config.query_var("num_threads"); i++)
    thread_create(lambda(int num) {
      while(1)
	{
	  object request = queue->read();
	  if (request)
	    {
	      werror(sprintf("Thread %d processing a request.\n", num));
	      request->process_start();
	    }
	}
      }, i );

  WERROR("Starting\n");
  return -17;
}
